//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_color4  Aqua 
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1  50

//
//
//
//
//

extern int                RsiLength           = 14;
extern ENUM_APPLIED_PRICE RsiPrice            = PRICE_CLOSE;
extern int                MaPeriod            = 10;
extern ENUM_MA_METHOD     MaType              = MODE_SMA;
extern bool               alertsOn            = true;
extern bool               alertsOnFiftyCross  = true;
extern bool               alertsOnSignalCross = true;
extern bool               alertsOnCurrent     = false;
extern bool               alertsMessage       = true;
extern bool               alertsSound         = true;
extern bool               alertsEmail         = false;
extern bool               alertsNotify        = false;

//
//
//
//
//

double rsi[];
double rsiDa[];
double rsiDb[];
double rsiMa[];
double trend[];
double slope[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
    IndicatorBuffers(6);
    SetIndexBuffer(0,rsi);
    SetIndexBuffer(1,rsiDa); 
    SetIndexBuffer(2,rsiDb); 
    SetIndexBuffer(3,rsiMa);
    SetIndexBuffer(4,trend);
    SetIndexBuffer(5,slope);
    
    IndicatorShortName("Rsi Ma ("+RsiLength+","+MaPeriod+")");
return(0);
}
int deinit()  {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,rsiDa,rsiDb);
   for(i=limit; i >= 0; i--) rsi[i] = iRsi(iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i),RsiLength,i);
   for(i=limit; i >= 0; i--)
   {
      rsiMa[i] = iMAOnArray(rsi,0,MaPeriod,0,MaType,i);
      rsiDa[i] = EMPTY_VALUE;
      rsiDb[i] = EMPTY_VALUE;
      trend[i] = trend[i+1]; 
      slope[i] = slope[i+1];
      if (rsi[i]>50)       slope[i] = 1;
      if (rsi[i]<50)       slope[i] =-1;
	   if (rsi[i]>rsiMa[i]) trend[i] = 1; 
	   if (rsi[i]<rsiMa[i]) trend[i] =-1; 
	   if (slope[i] == -1)  PlotPoint(i,rsiDa,rsiDb,rsi);         
   }    
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnFiftyCross && slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar,"crossing fifty up");
         if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar,"crossing fifty down");
      }
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnSignalCross && trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(time2,mess2,whichBar,"crossed signal up");
         if (trend[whichBar] == -1) doAlert(time2,mess2,whichBar,"crossed signal down");
      }
  
   } 
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

double iRsi(double price, double period, int i, int instanceNo=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int z = instanceNo*3; 
      int r = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   workRsi[r][z+_price] = price;
         double alpha = 1.0/period; 
         if (r<period)
            {
               int k; double sum = 0; for (k=0; k<period && (r-k-1)>=0; k++) sum += MathAbs(workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price]);
                  workRsi[r][z+_change] = (workRsi[r][z+_price]-workRsi[0][z+_price])/MathMax(k,1);
                  workRsi[r][z+_changa] =                                         sum/MathMax(k,1);
            }
         else
            {
               double change = workRsi[r][z+_price]-workRsi[r-1][z+_price];
                               workRsi[r][z+_change] = workRsi[r-1][z+_change] + alpha*(        change  - workRsi[r-1][z+_change]);
                               workRsi[r][z+_changa] = workRsi[r-1][z+_changa] + alpha*(MathAbs(change) - workRsi[r-1][z+_changa]);
            }
         if (workRsi[r][z+_changa] != 0)
               return(50.0*(workRsi[r][z+_change]/workRsi[r][z+_changa]+1));
         else  return(50.0);
   
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
   {
     if (first[i+2] == EMPTY_VALUE) 
     {
        first[i]   = from[i];
        first[i+1] = from[i+1];
        second[i]  = EMPTY_VALUE;
     }
     else
     {
       second[i]   =  from[i];
       second[i+1] =  from[i+1];
       first[i]    = EMPTY_VALUE;
     }
   }
   else
   {
       first[i]  = from[i];
       second[i] = EMPTY_VALUE;
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Rsi ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Rsi "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}